// #autoload
// #name = FrostyRepair
// #version = 1.3
// #date = January 18, 2002
// #author = Frosty
// #email = frostycubes@earthink.net
// #description = Autmatically uses a healthkit on pickup if health is not max.
// #credit = Falkor for requesting this script, as its the reason it was done.
// #status = Working

if(!isObject(FrostyR))
{
    if(isFile("prefs/FrostyPrefs.cs") && !$FrostyPrefsLoaded)
    {
        exec("prefs/FrostyPrefs.cs");
        $FrostyPrefsLoaded = true;
    }

    if($FrostyPref::Repair::Enabled $= "")
        $FrostyPref::Repair::Enabled = true;
}


package FrostyRepair
{
    function FCrepairToggle(%val)
    {
        if(%val)
        {
            $FrostyPref::Repair::Enabled = !$FrostyPref::Repair::Enabled;

            if($FrostyPref::Repair::Enabled)
                addMessageHudLine("\c2FrostyRepair Enabled");
            else
                addMessageHudLine("\c2FrostyRepair Disabled");
        }
    }

    function FCrepairUseKit()
    {
        if($FrostyPref::Repair::Enabled)
            use("repairkit");
    }

    function defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
    {
        if(StrStr(%msgString, "You picked up a repair kit.") != -1)
            FCrepairUseKit();

        parent::defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
    }

    function quit()
    {
        if(!$FrostyPrefsSaved)
        {
            export("$FrostyPref::*", "prefs/FrostyPrefs.cs", false);
            $FrostyPrefsSaved = true;
        }

        parent::quit();
    }

    function OptionsDlg::onWake(%this)
    {
        if(!$FCrepairBind)
        {
            $RemapName[$RemapCount] = "FrostyRepair Toggle";
            $RemapCmd[$RemapCount]  = "FCrepairToggle";
            $RemapCount++;
            $FCrepairBind = true;
        }
        parent::onWake(%this);
    }
};
activatePackage(FrostyRepair);
